function [samples] = quantizador(u,nq)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% Inicializao de algumas variaveis com zero %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
vec_nivel = zeros(1,nq);
vec_tr = zeros(1,nq-1);
quantizado = zeros(1,length(u));
flag = 0;

%Valor Min
vec_nivel(1)= min(u);
%Valor Max
vec_nivel(nq) = max(u);
%Delta
delta = (abs(max(u)-min(u)))/(nq -1);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%% Gera vetor de Nq nivel %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for i = 2 : nq -1 
    vec_nivel(i)= vec_nivel(1) + (i-1) * delta;
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%% Gera vetor de Nq - 1 trshold %%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
vec_tr(1) = min(u) + delta /2;
for i = 2: nq-1
    vec_tr(i) = vec_tr(1) + (i-1)* delta;
end


% Analisa cada amostra e compara com o valor de cada treshhold
for i = 1 : length(u)
    for j = 1 : length(vec_tr)       
        if u(i) <= vec_tr(j) && flag == 0            
            quantizado(i) = vec_nivel(j);
            flag = 1;
        elseif u(i)>vec_tr(j) && flag ==0          
            if j == length(vec_tr)
                flag = 1;
                quantizado(i)= vec_nivel(j+1);
            end
            
        end  
    end
    flag = 0;

end
    
samples = quantizado;



